Index: trunk/FACT++/Makefile.am
===================================================================
--- trunk/FACT++/Makefile.am	(revision 18177)
+++ trunk/FACT++/Makefile.am	(revision 18186)
@@ -40,5 +40,5 @@
 	biasctrl drivectrl agilentctrl \
 	mcp feedback ratescan ratecontrol \
-	tngweather lidctrl gpsctrl pwrctrl \
+	tngweather lidctrl gpsctrl sqmctrl pwrctrl \
 	magicweather magiclidar \
 	smartfact evtserver getevent \
@@ -102,4 +102,5 @@
 	dimserver.man \
 	drivectrl.man \
+	evtserver.man \
 	fadctrl.man \
 	feedback.man \
@@ -109,6 +110,7 @@
 	fscctrl.man \
 	ftmctrl.man \
+	getevent.man \
+	gpsctrl.man \
 	lidctrl.man \
-	gpsctrl.man \
 	magiclidar.man \
 	magicweather.man \
@@ -119,6 +121,5 @@
 	showlog.man \
 	smartfact.man \
-	evtserver.man \
-	getevent.man \
+	sqmctrl.man \
 	temperature.man \
 	timecheck.man \
@@ -339,4 +340,9 @@
     	libConfiguration.la
 
+sqmctrl_SOURCES = src/sqmctrl.cc src/LocalControl.h
+sqmctrl_LDADD   = libDim++.la libDim.la libDimExtension.la \
+       libStateMachine.la libTools.la libTime.la \
+       libConfiguration.la
+
 temperature_SOURCES = src/temperature.cc src/LocalControl.h
 temperature_LDADD   = libDim++.la libDim.la libDimExtension.la \
Index: trunk/FACT++/Makefile.in
===================================================================
--- trunk/FACT++/Makefile.in	(revision 18177)
+++ trunk/FACT++/Makefile.in	(revision 18186)
@@ -54,11 +54,12 @@
 	feedback$(EXEEXT) ratescan$(EXEEXT) ratecontrol$(EXEEXT) \
 	tngweather$(EXEEXT) lidctrl$(EXEEXT) gpsctrl$(EXEEXT) \
-	pwrctrl$(EXEEXT) magicweather$(EXEEXT) magiclidar$(EXEEXT) \
-	smartfact$(EXEEXT) evtserver$(EXEEXT) getevent$(EXEEXT) \
-	temperature$(EXEEXT) timecheck$(EXEEXT) showlog$(EXEEXT) \
-	fitsdump$(EXEEXT) fitscheck$(EXEEXT) fitsselect$(EXEEXT) \
-	zfits$(EXEEXT) $(am__EXEEXT_1) $(am__EXEEXT_2) $(am__EXEEXT_3) \
-	$(am__EXEEXT_4) $(am__EXEEXT_5) $(am__EXEEXT_6) \
-	$(am__EXEEXT_7) $(am__EXEEXT_8)
+	sqmctrl$(EXEEXT) pwrctrl$(EXEEXT) magicweather$(EXEEXT) \
+	magiclidar$(EXEEXT) smartfact$(EXEEXT) evtserver$(EXEEXT) \
+	getevent$(EXEEXT) temperature$(EXEEXT) timecheck$(EXEEXT) \
+	showlog$(EXEEXT) fitsdump$(EXEEXT) fitscheck$(EXEEXT) \
+	fitsselect$(EXEEXT) zfits$(EXEEXT) $(am__EXEEXT_1) \
+	$(am__EXEEXT_2) $(am__EXEEXT_3) $(am__EXEEXT_4) \
+	$(am__EXEEXT_5) $(am__EXEEXT_6) $(am__EXEEXT_7) \
+	$(am__EXEEXT_8)
 @HAS_GUI_TRUE@am__append_1 = fact
 @HAS_DBUS_TRUE@am__append_2 = skypeclient
@@ -435,4 +436,8 @@
 smartfact_DEPENDENCIES = libDim++.la libDim.la libDimExtension.la \
 	libStateMachine.la libTools.la libTime.la libConfiguration.la
+am_sqmctrl_OBJECTS = src/sqmctrl.$(OBJEXT)
+sqmctrl_OBJECTS = $(am_sqmctrl_OBJECTS)
+sqmctrl_DEPENDENCIES = libDim++.la libDim.la libDimExtension.la \
+	libStateMachine.la libTools.la libTime.la libConfiguration.la
 am_temperature_OBJECTS = src/temperature.$(OBJEXT)
 temperature_OBJECTS = $(am_temperature_OBJECTS)
@@ -557,6 +562,6 @@
 	$(readfits_SOURCES) sched.c $(scheduler_SOURCES) \
 	$(showlog_SOURCES) $(skypeclient_SOURCES) $(smartfact_SOURCES) \
-	$(temperature_SOURCES) $(test_SOURCES) $(time_SOURCES) \
-	$(timecheck_SOURCES) $(tngweather_SOURCES) \
+	$(sqmctrl_SOURCES) $(temperature_SOURCES) $(test_SOURCES) \
+	$(time_SOURCES) $(timecheck_SOURCES) $(tngweather_SOURCES) \
 	$(triggerschedule_SOURCES) $(viewer_SOURCES) $(webDid_SOURCES) \
 	$(zfits_SOURCES)
@@ -582,8 +587,8 @@
 	$(ratescan_SOURCES) $(readfits_SOURCES) sched.c \
 	$(scheduler_SOURCES) $(showlog_SOURCES) $(skypeclient_SOURCES) \
-	$(smartfact_SOURCES) $(temperature_SOURCES) $(test_SOURCES) \
-	$(time_SOURCES) $(timecheck_SOURCES) $(tngweather_SOURCES) \
-	$(triggerschedule_SOURCES) $(am__viewer_SOURCES_DIST) \
-	$(webDid_SOURCES) $(zfits_SOURCES)
+	$(smartfact_SOURCES) $(sqmctrl_SOURCES) $(temperature_SOURCES) \
+	$(test_SOURCES) $(time_SOURCES) $(timecheck_SOURCES) \
+	$(tngweather_SOURCES) $(triggerschedule_SOURCES) \
+	$(am__viewer_SOURCES_DIST) $(webDid_SOURCES) $(zfits_SOURCES)
 man1dir = $(mandir)/man1
 NROFF = nroff
@@ -870,4 +875,5 @@
 @HAS_HELP2MAN_TRUE@	dimserver.man \
 @HAS_HELP2MAN_TRUE@	drivectrl.man \
+@HAS_HELP2MAN_TRUE@	evtserver.man \
 @HAS_HELP2MAN_TRUE@	fadctrl.man \
 @HAS_HELP2MAN_TRUE@	feedback.man \
@@ -877,6 +883,7 @@
 @HAS_HELP2MAN_TRUE@	fscctrl.man \
 @HAS_HELP2MAN_TRUE@	ftmctrl.man \
+@HAS_HELP2MAN_TRUE@	getevent.man \
+@HAS_HELP2MAN_TRUE@	gpsctrl.man \
 @HAS_HELP2MAN_TRUE@	lidctrl.man \
-@HAS_HELP2MAN_TRUE@	gpsctrl.man \
 @HAS_HELP2MAN_TRUE@	magiclidar.man \
 @HAS_HELP2MAN_TRUE@	magicweather.man \
@@ -887,6 +894,5 @@
 @HAS_HELP2MAN_TRUE@	showlog.man \
 @HAS_HELP2MAN_TRUE@	smartfact.man \
-@HAS_HELP2MAN_TRUE@	evtserver.man \
-@HAS_HELP2MAN_TRUE@	getevent.man \
+@HAS_HELP2MAN_TRUE@	sqmctrl.man \
 @HAS_HELP2MAN_TRUE@	temperature.man \
 @HAS_HELP2MAN_TRUE@	timecheck.man \
@@ -1079,4 +1085,9 @@
  	libStateMachine.la libTools.la libTime.la \
     	libConfiguration.la
+
+sqmctrl_SOURCES = src/sqmctrl.cc src/LocalControl.h
+sqmctrl_LDADD = libDim++.la libDim.la libDimExtension.la \
+       libStateMachine.la libTools.la libTime.la \
+       libConfiguration.la
 
 temperature_SOURCES = src/temperature.cc src/LocalControl.h
@@ -1801,4 +1812,9 @@
 	@rm -f smartfact$(EXEEXT)
 	$(AM_V_CXXLD)$(CXXLINK) $(smartfact_OBJECTS) $(smartfact_LDADD) $(LIBS)
+src/sqmctrl.$(OBJEXT): src/$(am__dirstamp) \
+	src/$(DEPDIR)/$(am__dirstamp)
+sqmctrl$(EXEEXT): $(sqmctrl_OBJECTS) $(sqmctrl_DEPENDENCIES) $(EXTRA_sqmctrl_DEPENDENCIES) 
+	@rm -f sqmctrl$(EXEEXT)
+	$(AM_V_CXXLD)$(CXXLINK) $(sqmctrl_OBJECTS) $(sqmctrl_LDADD) $(LIBS)
 src/temperature.$(OBJEXT): src/$(am__dirstamp) \
 	src/$(DEPDIR)/$(am__dirstamp)
@@ -2066,4 +2082,5 @@
 	-rm -f src/skypeclient.$(OBJEXT)
 	-rm -f src/smartfact.$(OBJEXT)
+	-rm -f src/sqmctrl.$(OBJEXT)
 	-rm -f src/temperature.$(OBJEXT)
 	-rm -f src/test.$(OBJEXT)
@@ -2218,4 +2235,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/skypeclient.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/smartfact.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/sqmctrl.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/temperature.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@src/$(DEPDIR)/test.Po@am__quote@